/*
insn_rtor.c
Copyright © 2009 William Astle

This file is part of LWASM.

LWASM is free software: you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details.

You should have received a copy of the GNU General Public License along with
this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
for handling register to register mode instructions
*/

#define __insn_rtor_c_seen__

#include "lwasm.h"
#include "instab.h"

OPFUNC(insn_rtor)
{
	int r0, r1;
	static const char *regs = "D X Y U S PCW V A B CCDP0 0 E F ";
	
	lwasm_emitop(as, l, instab[opnum].ops[0]);
	// register to register (r0,r1)
	// registers are in order:
	// D,X,Y,U,S,PC,W,V
	// A,B,CC,DP,0,0,E,F
	r0 = lwasm_lookupreg2(regs, p);
	if (r0 < 0 || *(*p)++ != ',')
	{
		register_error(as, l, 1, "Bad operand");
		r0 = r1 = 0;
	}
	else
	{
		r1 = lwasm_lookupreg2(regs, p);
		if (r1 < 0)
		{
			register_error(as, l, 1, "Bad operand");
			r0 = r1 = 0;
		}
	}
	lwasm_emit(as, l, (r0 << 4) | r1);
}
